#include <iostream>
#include <vector>
using namespace std;

int main()
{
    size_t number_count;
    size_t bin_count;
    cout << " Enter number count: ";
    cin  >> number_count;
    vector<double> numbers(number_count);

    cout << "Enter numbers: ";
    for (size_t i = 0; i < number_count; i++) {
        cin >> numbers[i];
    }

    cout << " Enter bin count: ";
    cin  >> bin_count;
    vector<size_t> bins(bin_count);


    double min = numbers[0];
    double max = numbers[0];
    for (double x : numbers) {
        if (x < min) {
            min = x;
        }
        else if (x > max) {
            max = x;
        }
    }

    double bin_size = (max - min) / bin_count;

    for(size_t i = 0; i<number_count; i++){
        bool found = false;
        for(size_t j=0; (j<bin_count-1) && !found; j++){
            auto lo = min + j*bin_size;
            auto hi = min+(j+1)*bin_size;
            if((lo<= numbers[i]) && (numbers[i] < hi)){
                bins[j]++;
                found = true;
            }
        }
        if(!found){
            bins[bin_count - 1 ]++;
        }
    }

    for (size_t i = 0; i < bin_count; i++) {
            cout << bins[i] << "|";
    for (size_t j = 0; j < bins[i]; j++) {
        cout << '*';
        }
    cout << endl;
    }
    short space_count;
    for (int i = 0; i<bin_count; i++){
        if (bins[i] < 10){
            space_count = 2;
        }
        else if (bins[i]>=10 && bins[i]<100){
            space_count = 1;
        }
        else if (bins[i]>=100 && bins[i]<1000){
            space_count = 0;
        }
        for (int k = 0; k<space_count; k++){
            cout << " ";
        }
        cout << bins[i];
        cout << "|";
        for (int j = 0; j<bins[i]; j++){
            if (bins[i] <= 80){
                cout << "*";
            } else{
                cout << ">80";
            }
        }
        cout << endl;
    }
    return 0;
}
